# coding: utf-8

"""
    P2RX API

    API for the P2RX Backend 

    The version of the OpenAPI document: 0.1.DEV-0
    Contact: paul.tindall@rxfoundry.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from rxfoundry.clients.p2rx_api.models.pricing_program import PricingProgram
from typing import Optional, Set
from typing_extensions import Self

class PharmacyProgramPricing(BaseModel):
    """
    PharmacyProgramPricing
    """ # noqa: E501
    pricing_program: Optional[PricingProgram] = None
    from_date: Optional[date] = None
    to_date: Optional[date] = None
    dispensing_fee: Optional[Union[StrictFloat, StrictInt]] = None
    transaction_fee: Optional[Union[StrictFloat, StrictInt]] = None
    ingredient_cost_markup: Optional[Union[StrictFloat, StrictInt]] = None
    __properties: ClassVar[List[str]] = ["pricing_program", "from_date", "to_date", "dispensing_fee", "transaction_fee", "ingredient_cost_markup"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PharmacyProgramPricing from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of pricing_program
        if self.pricing_program:
            _dict['pricing_program'] = self.pricing_program.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PharmacyProgramPricing from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "pricing_program": PricingProgram.from_dict(obj["pricing_program"]) if obj.get("pricing_program") is not None else None,
            "from_date": obj.get("from_date"),
            "to_date": obj.get("to_date"),
            "dispensing_fee": obj.get("dispensing_fee"),
            "transaction_fee": obj.get("transaction_fee"),
            "ingredient_cost_markup": obj.get("ingredient_cost_markup")
        })
        return _obj


